var _excluded = ["columns", "defaultSelectFields", "onOk", "fieldDragWidth", "fieldDragProps", "fieldCheckboxProps", "className", "watchSelectFields", "isMultipleDragGroup"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useImperativeHandle, forwardRef } from 'react';
import classnames from 'classnames';
import { PREFIX_CLS } from "../constants/dictionary";
import { StoreContext, useMultipleDataHandle } from "./hooks";
import { useUpdateEffect } from 'ahooks';
import FieldCheckbox from "./FieldCheckbox";
import FieldDrag from "./FieldDrag";
import FieldSingleSetting from "./FieldSingleSetting";
import MultipleFieldsModal from "./MultipleFieldsModal";
import SingleFieldsModal from "./SingleFieldsModal";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-fieldSetting");
var FieldSetting = /*#__PURE__*/forwardRef(function (props, ref) {
  var columns = props.columns,
      defaultSelectFields = props.defaultSelectFields,
      onOk = props.onOk,
      fieldDragWidth = props.fieldDragWidth,
      fieldDragProps = props.fieldDragProps,
      fieldCheckboxProps = props.fieldCheckboxProps,
      className = props.className,
      watchSelectFields = props.watchSelectFields,
      _props$isMultipleDrag = props.isMultipleDragGroup,
      isMultipleDragGroup = _props$isMultipleDrag === void 0 ? true : _props$isMultipleDrag,
      restProps = _objectWithoutProperties(props, _excluded);

  var data = useMultipleDataHandle(columns || []);
  var selectFields = data.selectFields;

  var contextValue = _objectSpread({
    columns: columns,
    defaultSelectFields: defaultSelectFields,
    fieldDragWidth: fieldDragWidth,
    isMultipleDragGroup: isMultipleDragGroup
  }, data);

  useUpdateEffect(function () {
    watchSelectFields && watchSelectFields(selectFields);
  }, [selectFields]);
  useImperativeHandle(ref, function () {
    return {
      sortOk: sortOk,
      selectFields: selectFields
    };
  });

  var sortOk = function sortOk() {
    return onOk && onOk(selectFields);
  };

  return /*#__PURE__*/React.createElement(StoreContext.Provider, {
    value: contextValue
  }, /*#__PURE__*/React.createElement("div", _extends({
    className: classnames(prefixCls, className)
  }, restProps), /*#__PURE__*/React.createElement(FieldCheckbox, _extends({
    isCheckboxGroup: true
  }, fieldCheckboxProps)), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-line")
  }), /*#__PURE__*/React.createElement(FieldDrag, _extends({
    isDragGroup: true
  }, fieldDragProps))));
});
FieldSetting.FieldSingleSetting = FieldSingleSetting;
FieldSetting.MultipleFieldsModal = MultipleFieldsModal;
FieldSetting.SingleFieldsModal = SingleFieldsModal;
export default FieldSetting;