import React, { useEffect } from 'react';
import { Tag, Typography } from 'rlj-design';
import { useStoreContext } from "../hooks";
import { PREFIX_CLS } from "../../constants/dictionary";
import "../style/fieldDrag.less";
var LongText = Typography.LongText;
export var FieldSingleDrag = function FieldSingleDrag() {
  var prefixCls = "".concat(PREFIX_CLS, "-fieldSingleDrag");

  var _useStoreContext = useStoreContext(),
      defaultSelectFields = _useStoreContext.defaultSelectFields,
      selectFields = _useStoreContext.selectFields,
      setCheckedValueMap = _useStoreContext.setCheckedValueMap,
      checkedValueMap = _useStoreContext.checkedValueMap;

  useEffect(function () {
    if (!defaultSelectFields) return;
    var temp = defaultSelectFields.map(function (_ref) {
      var fieldId = _ref.fieldId;
      return fieldId;
    });
    checkedValueMap.set('single', temp);
    setCheckedValueMap(new Map(checkedValueMap));
  }, [defaultSelectFields]);

  var closeTag = function closeTag(id) {
    var _checkedValueMap$get;

    var restValue = (_checkedValueMap$get = checkedValueMap.get('single')) === null || _checkedValueMap$get === void 0 ? void 0 : _checkedValueMap$get.filter(function (item) {
      return !item.includes(id);
    });

    if (restValue !== null && restValue !== void 0 && restValue.length) {
      checkedValueMap.set('single', restValue);
    } else {
      checkedValueMap.delete('single');
    }

    setCheckedValueMap(new Map(checkedValueMap));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: prefixCls
  }, selectFields === null || selectFields === void 0 ? void 0 : selectFields.map(function (_ref2) {
    var fieldId = _ref2.fieldId,
        fieldDisabled = _ref2.fieldDisabled,
        fieldName = _ref2.fieldName;
    return /*#__PURE__*/React.createElement(Tag, {
      key: fieldId,
      type: "selected",
      closable: true,
      height: 24,
      disabled: fieldDisabled,
      onClose: function onClose() {
        return closeTag(fieldId);
      },
      style: {
        color: fieldDisabled ? undefined : '#7f7f85',
        marginBottom: 6,
        marginRight: 6
      }
    }, /*#__PURE__*/React.createElement(LongText, {
      text: fieldName || '',
      length: 24,
      tooltip: fieldName
    }));
  }));
};